/*
 * Copyright (c) 2008 Jesper Karlsson & David Gustafsson
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __XFBIB_LIST_STORE_H
#define __XFBIB_LIST_STORE_H

#include <gtk/gtk.h>
#include "xfbib-bibtex.h"

#define XFBIB_TYPE_LIST_STORE             (xfbib_list_store_get_type())
#define XFBIB_LIST_STORE(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), XFBIB_TYPE_LIST_STORE, XfbibListStore))
#define XFBIB_IS_LIST_STORE(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), XFBIB_TYPE_LIST_STORE))
#define XFBIB_LIST_STORE_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), XFBIB_TYPE_LIST_STORE, XfbibListStoreClass))
#define XFBIB_IS_LIST_STORE_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), XFBIB_TYPE_LIST_STORE))
#define XFBIB_LIST_STORE_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS((obj), XFBIB_TYPE_LIST_STORE, XfbibListStoreClass))

G_BEGIN_DECLS

typedef struct _XfbibListStore         XfbibListStore;

GType xfbib_list_store_get_type() G_GNUC_CONST;

XfbibListStore *xfbib_list_store_new(enum XFBIB_BIBTEX_TYPE);
gboolean xfbib_list_store_remove(XfbibListStore *, GtkTreeIter  *);
void xfbib_list_store_clear(XfbibListStore *);
void xfbib_list_store_row_inserted(XfbibListStore *, gint);
GObject *xfbib_list_store_get(XfbibListStore *, GtkTreeIter *);
void xfbib_list_store_add(XfbibListStore *, GObject *);
void xfbib_list_store_replace(XfbibListStore *, GObject *, GObject *);

G_END_DECLS

#endif //__XFBIB_LIST_STORE_H

